package com.josh.dome;

import org.joshvm.ui.Container;
import org.joshvm.ui.Display;
import org.joshvm.ui.Screen;

public class Application {
	public static Screen screen ;
	public static Display display;
	public static TimeCallBack timeCallBack;
	
	
	public static void init(){
		display = Display.getDisplay();
		screen = new Screen();
		startTimer();
	}
	
	public static void changeDisplay(Container newCon,Container oldCon){
		screen.removeContainer(oldCon);
		screen.addContainer(newCon);
		display.setScreen(screen);
	}
	
	public static void showDisplay(){
		display.setScreen(screen);
	}

	
	public static void setTimeCallBack (TimeCallBack timeCallBack){
		Application.timeCallBack = timeCallBack;
	}
	
	
	private static void startTimer(){
		new Thread(new Runnable() {
			public void run() {
				while(true){
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					if(null != timeCallBack){
						timeCallBack.time(System.currentTimeMillis());
					}
				}
			}
		}).start();
		
		
	}
	
}
