package com.josh.dome.startpage;

import java.io.IOException;

import org.joshvm.ui.Color;
import org.joshvm.ui.Container;
import org.joshvm.ui.Font;
import org.joshvm.ui.Screen;
import org.joshvm.ui.UIObject;
import org.joshvm.ui.Widget;
import org.joshvm.ui.layout.Flex;
import org.joshvm.ui.listener.ClickedListener;
import org.joshvm.ui.widget.Canvas;
import org.joshvm.ui.widget.Image;
import org.joshvm.ui.widget.Label;

import com.josh.dome.Application;
import com.josh.dome.base.BasePage;
import com.josh.dome.contant.Contant;
import com.josh.dome.utils.UtilTime;

public class StartPage extends BasePage {
	private Screen screen;
	private Container container;
	private static StartPage self;
	private Label timeLable;
	private Label changing;
	private Label perLabel;
	private Label shenTimeLabel;
	private Label timeCoastlabel;
	private Font font;

	private int state = 1;

	public StartPage(Screen screen) {
		this.screen = screen;
	}

	public static StartPage getSelf() {
		if (null == self) {
			self = new StartPage(Application.screen);
			Application.setTimeCallBack(self);
		}
		return self;
	}

	public Container getContainer() {
		return container;
	}

	private void makeTitleUi() {
		Label titleBg = new Label();
		titleBg.setWidth(Contant.SC_WIDTH);
		titleBg.setText("");
		titleBg.setHeight(Contant.TITLE_HEIGHT);
		titleBg.setBackgroundColor(Color.BLACK);
		titleBg.setPos(0, 0);
		screen.addObject(titleBg);

		Image backImage = new Image();
		backImage.setHeight(32);
		backImage.setWidth(32);
		backImage.setBackgroundColor(Color.BLACK);
		try {
			backImage.setSource("/back.png");
		} catch (IOException e) {
			e.printStackTrace();
		}
		backImage.setPos(5, 9);
		screen.addWidget(backImage);

		Label backLabel = new Label();
		backLabel.setWidth(35);
		backLabel.setText("返回");
		backLabel.setTextAlign(UIObject.ALIGN_LEFT);
		backLabel.setTextColor(Color.WHITE);
		backLabel.setBackgroundColor(Color.BLACK);
		backLabel.setPos(35, 15);
		screen.addWidget(backLabel);

		Label backCon = new Label();
		backCon.setHeight(Contant.TITLE_HEIGHT);
		backCon.setWidth(75);
		backCon.setText("");
		backCon.setBackgroundColor(new Color(0x00, 0xFF, 0xFF, 0xFF));
		backCon.setPos(0, 0);
		backCon.setClickable(true);
		screen.addWidget(backCon);
		backCon.setClickedListener(new ClickedListener() {

			public void onClicked(UIObject uiobject) {
				System.out.println("click back");

			}
		});

		timeLable = new Label();
		timeLable.setText("");
		timeLable.setWidth(150);
		timeLable.setBackgroundColor(Color.BLACK);
		timeLable.setTextColor(Color.WHITE);
		timeLable.setPos(325, 15);
		screen.addWidget(timeLable);

		Image wifiImage = new Image();
		try {
			wifiImage.setSource("/wifi.png");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		wifiImage.setPos(735, 10);
		screen.addWidget(wifiImage);

		Image powerImage = new Image();
		try {
			powerImage.setSource("/power.png");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		powerImage.setPos(765, 10);
		screen.addWidget(powerImage);

	}

	private void makeChangeUi() {
		
		screen.setBackgroundColor(Color.BLACK);
	    Label lineLabel = new Label();
	    lineLabel.setWidth(800);
	    lineLabel.setHeight(1);
//	    lineLabel.setBackgroundColor(new Color(0x47,0x84,0x8E));
	    lineLabel.setBackgroundColor(Color.GREEN);
	    lineLabel.setPos(0, 51);
	    screen.addWidget(lineLabel);

		//电压
	    Label evLabel = new Label();
	    evLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
	    evLabel.setTextColor(Color.GREEN);
	    evLabel.setText("电压：470.80 V");
	    font = Font.getFont(24);
	    evLabel.setTextFont(font);
	    evLabel.setPos(470, 280);
		screen.addWidget(evLabel);
		
		//电流
	    Label eiLabel = new Label();
	    eiLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
	    eiLabel.setTextColor(Color.GREEN);
	    eiLabel.setText("电流：87.90 A");
	    font = Font.getFont(24);
	    eiLabel.setTextFont(font);
	    eiLabel.setPos(470, 330);
		screen.addWidget(eiLabel);
		
		//累积电量
	    Label wLabel = new Label();
	    wLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
	    wLabel.setTextColor(Color.GREEN);
	    wLabel.setText("充电电量：0.98 kWh");
	    font = Font.getFont(24);
	    wLabel.setTextFont(font);
	    wLabel.setPos(470, 380);
		screen.addWidget(wLabel);
		
		//充电时长
		timeCoastlabel = new Label();
		timeCoastlabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
		timeCoastlabel.setTextColor(Color.GREEN);
		timeCoastlabel.setText("充电时长：00：03：12");
	    font = Font.getFont(30);
	    timeCoastlabel.setTextFont(font);
	    timeCoastlabel.setPos(465, 125);
		screen.addWidget(timeCoastlabel);
	    
	    Label comLabel = new Label();
	    comLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
	    comLabel.setTextColor(Color.GREEN);
	    comLabel.setText("JOSH北京西国贸充电站");
	    font = Font.getFont(35);
	    comLabel.setTextFont(font);
	    comLabel.setPos(25, 80);
		screen.addWidget(comLabel);
		
	    Label zhengLabel = new Label();
	    zhengLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
	    zhengLabel.setTextColor(Color.GRAY);
	    zhengLabel.setText("充电桩编号: No.Josh88866");
	    zhengLabel.setPos(100, 140);
		screen.addWidget(zhengLabel);

		Canvas chanPrCan = new Canvas(200, 200);
		chanPrCan.setLineColorOfDraw(Color.GRAY);
		chanPrCan.setLineWidthOfDraw(10);
		chanPrCan.setShadowColorOfDraw(Color.GRAY);
		chanPrCan.drawArc(100, 100, 100, 288, 360);

		chanPrCan.setLineColorOfDraw(Color.GREEN);
		chanPrCan.setLineWidthOfDraw(10);
		chanPrCan.setShadowColorOfDraw(Color.GREEN);
		chanPrCan.drawArc(100, 100, 100, 360, 288);
		
		chanPrCan.setLineColorOfDraw(Color.GRAY);
		chanPrCan.setLineWidthOfDraw(1);
		chanPrCan.setShadowColorOfDraw(Color.GRAY);
		chanPrCan.drawArc(100, 100, 116, 0, 360);
		
		chanPrCan.setPos(100, 200);
		screen.addObject(chanPrCan);

		Image lightImage = new Image();
		lightImage.setHeight(32);
		lightImage.setWidth(32);
		try {
			lightImage.setSource("/light32.png");
		} catch (IOException e) {
			e.printStackTrace();
		}
		lightImage.setPos(185, 220);
		screen.addWidget(lightImage);
		
		Image carImage = new Image();
		carImage.setHeight(56);
		carImage.setWidth(150);
		try {
			carImage.setSource("/car150.png");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		carImage.setPos(125, 265);
		screen.addWidget(carImage);

		perLabel = new Label();
		perLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
		perLabel.setTextColor(new Color(0x47,0x84,0x8E));
		perLabel.setText("80%");
		perLabel.setPos(190, 290);
		screen.addWidget(perLabel);
		
		changing = new Label();
		changing.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
		changing.setTextColor(Color.GREEN);
		state = 1;
		changing.setText("充电中..");
		changing.setPos(170, 340);
		screen.addWidget(changing);
		
		Label shenLabel = new Label();
		shenLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
		shenLabel.setTextColor(Color.WHITE);
		shenLabel.setText("预计充电时间剩余         分钟");
		shenLabel.setPos(100, 430);
		screen.addWidget(shenLabel);
		
		shenTimeLabel = new Label();
		shenTimeLabel.setBackgroundColor(new Color(0x00, 0xff, 0xff, 0xff));
		shenTimeLabel.setTextColor(Color.GREEN);
		shenTimeLabel.setText("15");
		shenTimeLabel.setPos(240, 430);
		screen.addWidget(shenTimeLabel);
		
		
		Canvas pPriceCan = new Canvas(400, 170);
		pPriceCan.setLineColorOfDraw(Color.GREEN);
		pPriceCan.setBackgroundColorOfDraw(new Color(0x00,0xFF,0xFF,0xFF));
		pPriceCan.setLineWidthOfDraw(2);
		pPriceCan.setRectRadiusOfDraw(10);
		pPriceCan.setShadowColorOfDraw(Color.GREEN);
		pPriceCan.drawRect(25, 0, 350, 160);
		
		
		pPriceCan.setLineColorOfDraw(new Color(0xAA,0x00,0x00,0x00));
		pPriceCan.drawLine(85, 1, 315, 1);
		pPriceCan.drawLine(85, 159, 315, 159);
		pPriceCan.drawLine(26, 40, 26, 120);
		pPriceCan.drawLine(374, 40, 374, 120);
		pPriceCan.setPos(400, 70);
		screen.addObject(pPriceCan);
		
		
		
		
		
		
		
		Canvas zheLineCan = new Canvas(400, 220);
		zheLineCan.setLineColorOfDraw(Color.GREEN);
		zheLineCan.setBackgroundColorOfDraw(new Color(0x00,0xFF,0xFF,0xFF));
		zheLineCan.setLineWidthOfDraw(2);
		zheLineCan.setRectRadiusOfDraw(10);
		zheLineCan.setShadowColorOfDraw(Color.GREEN);
		zheLineCan.drawRect(25, 10, 350, 210);
		zheLineCan.setLineColorOfDraw(new Color(0xAA,0x00,0x00,0x00));
		zheLineCan.drawLine(85, 11, 315, 11);
		zheLineCan.drawLine(85, 219, 315, 219);
		zheLineCan.drawLine(26, 50, 26, 180);
		zheLineCan.drawLine(374, 50, 374, 180);
		
		zheLineCan.setPos(400, 240);
		screen.addObject(zheLineCan);
		
		
		

	}

	public void makeUi() {
		makeTitleUi();
		makeChangeUi();
		
		new Thread(new Runnable() {
			 private long startTime ;
			public void run() {
				startTime = System.currentTimeMillis();
				while (true) {  
		            long currentTime = System.currentTimeMillis();  
		            long elapsedMilliseconds = currentTime - startTime;  
		  
		            long seconds = (elapsedMilliseconds / 1000) % 60;  
		            long minutes = (elapsedMilliseconds / (1000 * 60)) % 60;  
		            long hours = elapsedMilliseconds / (1000 * 60 * 60);  
		            System.out.println(hours+":"+minutes+":"+seconds);
		            
		            // 使用字符串连接构造时间字符串  
		            String timeString = "充电时长：" 
		            					+ (hours < 10 ? "0" + hours : hours+"") +  
		                                ":" + (minutes < 10 ? "0" + minutes : minutes+"") +  
		                                ":" + (seconds < 10 ? "0" + seconds : seconds+"");  
		  
		            timeCoastlabel.setText(timeString);
		  
		            try {  
		                Thread.sleep(1000); // Sleep for 1 second  
		            } catch (InterruptedException e) {  
		                e.printStackTrace();  
		            }  
		        }  
				
			}
		}).start();
	}

	public void settime(long currentTimeMillis) {
		if (null != timeLable) {
			timeLable.setText(UtilTime.getDateAndTime(currentTimeMillis));
		}
		if (null != changing) {
			if (state == 1) {
				changing.setText("充电中..");
			} else if (state == 2) {
				changing.setText("充电中....");
			} else if (state == 3) {
				changing.setText("充电中......");
			}
			state = state + 1;
			if (state == 4) {
				state = 1;
			}
		}
	}

}
